/*
Ощущение действий с Пульта
*/

package action_sensor

import "time"

////////////////////////////////////////
func init(){

}
/////////////////////////////////////////
var pulsCount=0
// срабатывает с каждым пульсом
func ActionSensorPuls(puls int){
	pulsCount=puls
	checkCurActions()
}

/* список активных действий с Пульта
Могут быть совершены сразу несколько действий, контекст которых удерживаются в течении 10 секунд.
В ActionFromPult сохраняется время активации действия в числе пульсов pulsCount
0 Нет никаких действий с Пульта
1 Непонятно
2 Понятно
3 Наказать
4 Поощрить
5 Накормить
6 Успокоить
7 Предложить поиграть
8 Предложить поучить
9 Игнорировать
10 Сделать больно
11 Сделать приятно
12 Заплакать
13 Засмеяться
14 Обрадоваться
15 Испугаться
16 Простить
 */
var ActionFromPult[17]int


/////////////////////////////////////////
func SetActionFromPult(action int){
	ActionFromPult[0]=0
	ActionFromPult[action]=pulsCount
	// дезактивировать этот контекст через 10 секунд
	time.AfterFunc(10*time.Second, func() {
		ActionFromPult[action]=0
	})
}
//////////////////////////////////////////

// какие акции действуют в данный момент пульса - активные контексты действий с Пульта
func checkCurActions()([]int){
	var aArr[]int
	for i := 1; i < 17; i++ {
		if ActionFromPult[i]>0{
			aArr=append(aArr,i)
		}
	}
	if aArr==nil{
		ActionFromPult[0]=0
	}
	return aArr
}
////////////////////////////////////////////////